%define _with_repolib 1

%define version_maj 1
%define version_min 2
%define version_rev 1

# If you want repolib package to be built,
# issue the following: 'rpmbuild --with repolib'
%define with_repolib %{?_with_repolib:1}%{!?_with_repolib:0}
%define without_repolib %{!?_with_repolib:1}%{?_with_repolib:0}

%define repodir %{_javadir}/repository.jboss.com/jboss/%{name}/%{version}.%{reltag}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%define reltag  GA_CP02

Summary:        JBoss Web Services (jboss42)
Name:           jbossws-jboss42
Version:        %{version_maj}.%{version_min}.%{version_rev}
Release:        0jpp.ep1.2%{?dist}.1
Epoch:          0
License:        LGPL
Group:          Development/Java
URL:            http://labs.jboss.com/jbossws/

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot
BuildArch:      noarch
Source0:        %{name}-%{version}.%{reltag}-tp.tar.gz
Source1:        jbossas-4.2.x-tp.tar.gz
Source2:        %{name}-component-info.xml

BuildRequires:  ws-commons-policy-repolib >= 0:1.0
BuildRequires:  wsdl4j16 >= 1.6.2
BuildRequires:  xml-security >= 1.3.0

%description
JBossWS an implementation of J2EE Web Services


%if %{with_repolib}
%package     repolib
Summary:     Artifacts to be uploaded to a repository library
Group:  Development/Libraries/Java

%description     repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio
%endif


%prep
%setup -n %{name} 

sed -i 's/@VERSION@/%{version}.%{reltag}-brew/g' %{SOURCE2}
tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
sed -i "s/@TAG@/$tag/g" %{SOURCE2}


%build
# FIXME: One day this should actually... you know, build something.

#######################################################################
# pwd: <builddir>/jbossws-jboss42
gzip -dc %{SOURCE1} | tar -xvvf -
cp %{version}.%{reltag}/lib/jbossws42.sar .
mkdir sarcontent
unzip jbossws42.sar -d sarcontent

cd sarcontent

#######################################################################
# pwd: <builddir>/jbossws-jboss42/sarcontent

# Replacing jaxb-api, jaxb-impl, jboss-jaxws, jbossws-core and stax-api
# with copies from the jbossas thirdparty blob
rm -f jaxb-api.jar jaxb-impl.jar jboss-jaxws.jar jbossws-core.jar \
      stax-api.jar
cp ../thirdpartyrepo/sun-jaxb/2.0.3jboss/lib/jaxb-api.jar .
cp ../thirdpartyrepo/sun-jaxb/2.0.3jboss/lib/jaxb-impl.jar .
cp ../thirdpartyrepo/jboss/jbossws/1.2.1.GA_CP02/lib/jboss-jaxws.jar .
cp ../thirdpartyrepo/jboss/jbossws/1.2.1.GA_CP02/lib/jbossws-core.jar .
cp ../thirdpartyrepo/stax-api/1.0/lib/stax-api.jar .

# Replacing wsdl4j, policy and xmlsec with Brew-built versions
rm -f wsdl4j.jar xmlsec.jar policy.jar
cp --dereference %{_javadir}/wsdl4j/wsdl4j16.jar .
cp --dereference %{_javadir}/xmlsec.jar .
#FIXME Do the same for policy and BR it
cp --dereference %{_javadir}/repository.jboss.com/wscommons-policy/1.0-brew/lib/policy.jar .


%install
rm -rf $RPM_BUILD_ROOT

%define install_location %{_javadir}/%{name}/sar

install -d -m 0755 $RPM_BUILD_ROOT%{install_location}
cp -r sarcontent/* $RPM_BUILD_ROOT%{install_location}

%if %{with_repolib}
    install -d -m 755 $RPM_BUILD_ROOT%{repodir}
    install -d -m 755 $RPM_BUILD_ROOT%{repodirlib}
    install -d -m 755 $RPM_BUILD_ROOT%{repodirsrc}

    install -m 755 %{SOURCE2} $RPM_BUILD_ROOT%{repodir}/component-info.xml
    cp %{version}.%{reltag}/lib/jbossws42-src.zip $RPM_BUILD_ROOT%{repodirlib}

    # We're just going to copy source 0, even though most of the content of the SAR
    # which we use comes from source 1. One day soon(?) we'll actually be building
    # from source, so this should be of little importance now.
    install -m 755 %{SOURCE0} $RPM_BUILD_ROOT%{repodirsrc}

    # Re-constituting the SAR
    pushd sarcontent
    zip -r jbossws42.sar .
    cp jbossws42.sar $RPM_BUILD_ROOT%{repodirlib}
    popd
    
%endif


%clean
rm -rf $RPM_BUILD_ROOT


%files
%defattr(0644,root,root,0755)
%{_javadir}/%{name}

%if %{with_repolib}
%files repolib
%defattr(0644,root,root,0755)
%{repodir}
%endif


%changelog
* Fri Feb 01 2008 Fernando Nasser <fnasser@redhat.com> 0:1.2.1-1.GA_CP02.0jpp.ep1.2.1
- Use wsdl4j16 in RHEL-5

* Sat Jan 26 2008 Fernando Nasser <fnasser@redhat.com> 0:1.2.1-1.GA_CP02.0jpp.ep1.2
- Update component-info

* Sat Jan 26 2008 Fernando Nasser <fnasser@redhat.com> 0:1.2.1-1.GA_CP02.0jpp.ep1.1
- Upgrade to CP02
- Use EAP policy JAR

* Tue Nov 06 2007 Jon Prindiville <jprindiv@redhat.com> 0:1.2.1-0jpp.ep1.2
- Added missing defattr to files list

* Fri Nov 2 2007 Jon Prindiville <jprindiv@redhat.com> 0:1.2.1-0jpp.ep1.1
- First release
